Index: XIOS/trunk/src/node/distribution_client.cpp
===================================================================
--- XIOS/trunk/src/node/distribution_client.cpp	(revision 572)
+++ XIOS/trunk/src/node/distribution_client.cpp	(revision 575)
@@ -49,5 +49,5 @@
   std::vector<CDomain*> domList = grid->getDomains();
   std::vector<CAxis*> axisList = grid->getAxis();
-  CArray<bool,1> axisDomainOrder = grid->axisDomainOrder;
+  CArray<bool,1> axisDomainOrder = grid->axis_domain_order;
 
   std::vector<CDomain*>::iterator itbDom, iteDom, itDom;
Index: XIOS/trunk/src/node/grid.cpp
===================================================================
--- XIOS/trunk/src/node/grid.cpp	(revision 572)
+++ XIOS/trunk/src/node/grid.cpp	(revision 575)
@@ -231,23 +231,23 @@
       switch (dim) {
         case 1:
-          checkGridMask(mask1, domainMasks, axisMasks, axisDomainOrder);
+          checkGridMask(mask1, domainMasks, axisMasks, axis_domain_order);
           break;
         case 2:
-          checkGridMask(mask2, domainMasks, axisMasks, axisDomainOrder);
+          checkGridMask(mask2, domainMasks, axisMasks, axis_domain_order);
           break;
         case 3:
-          checkGridMask(mask3, domainMasks, axisMasks, axisDomainOrder);
+          checkGridMask(mask3, domainMasks, axisMasks, axis_domain_order);
           break;
 //        case 4:
-//          checkGridMask(mask4, domainMasks, axisMasks, axisDomainOrder);
+//          checkGridMask(mask4, domainMasks, axisMasks, axis_domain_order);
 //          break;
 //        case 5:
-//          checkGridMask(mask5, domainMasks, axisMasks, axisDomainOrder);
+//          checkGridMask(mask5, domainMasks, axisMasks, axis_domain_order);
 //          break;
 //        case 6:
-//          checkGridMask(mask6, domainMasks, axisMasks, axisDomainOrder);
+//          checkGridMask(mask6, domainMasks, axisMasks, axis_domain_order);
 //          break;
 //        case 7:
-//          checkGridMask(mask7, domainMasks, axisMasks, axisDomainOrder);
+//          checkGridMask(mask7, domainMasks, axisMasks, axis_domain_order);
 //          break;
         default:
@@ -263,5 +263,5 @@
       if (!domListP.empty())
       {
-        computeGridGlobalDimension(getDomains(), getAxis(), axisDomainOrder);
+        computeGridGlobalDimension(getDomains(), getAxis(), axis_domain_order);
         for (int i = 0; i < domListP.size(); ++i)
         {
@@ -282,7 +282,7 @@
         int idx = 0;
         std::vector<int> axisPositionMap;
-        for (int i = 0; i < axisDomainOrder.numElements(); ++i)
+        for (int i = 0; i < axis_domain_order.numElements(); ++i)
         {
-          if (false == axisDomainOrder(i))
+          if (false == axis_domain_order(i))
           {
             axisPositionMap.push_back(idx);
@@ -292,5 +292,5 @@
         }
 
-        computeGridGlobalDimension(getDomains(), getAxis(), axisDomainOrder);
+        computeGridGlobalDimension(getDomains(), getAxis(), axis_domain_order);
         for (int i = 0; i < axisListP.size(); ++i)
         {
@@ -385,16 +385,16 @@
 
       //By default, domains are always the first ones of a grid
-      if (grid->axisDomainOrder.isEmpty())
+      if (grid->axis_domain_order.isEmpty())
       {
         int size = domains.size()+axis.size();
-        grid->axisDomainOrder.resize(size);
+        grid->axis_domain_order.resize(size);
         for (int i = 0; i < size; ++i)
         {
-          if (i < domains.size()) grid->axisDomainOrder(i) = true;
-          else grid->axisDomainOrder(i) = false;
+          if (i < domains.size()) grid->axis_domain_order(i) = true;
+          else grid->axis_domain_order(i) = false;
         }
       }
 
-      grid->computeGridGlobalDimension(domains, axis, grid->axisDomainOrder);
+      grid->computeGridGlobalDimension(domains, axis, grid->axis_domain_order);
 
       return (grid);
@@ -586,5 +586,5 @@
        CContext* context = CContext::getCurrent() ;
        CContextServer* server=context->server ;
-       int idx = 0, numElement = axisDomainOrder.numElements();
+       int idx = 0, numElement = axis_domain_order.numElements();
        int ssize = numElement;
        std::vector<int> indexMap(numElement);
@@ -592,5 +592,5 @@
        {
          indexMap[i] = idx;
-         if (true == axisDomainOrder(i))
+         if (true == axis_domain_order(i))
          {
             ++ssize;
@@ -607,5 +607,5 @@
        for (int i = 0; i < numElement; ++i)
        {
-         if (axisDomainOrder(i))
+         if (axis_domain_order(i))
          {
             nZoomBegin[indexMap[i]]   = domainList[domainId]->zoom_ibegin_srv;
@@ -1018,8 +1018,8 @@
     {
       int sizeOrd = order.size();
-      axisDomainOrder.resize(sizeOrd);
+      axis_domain_order.resize(sizeOrd);
       for (int i = 0; i < sizeOrd; ++i)
       {
-        axisDomainOrder(i) = order[i];
+        axis_domain_order(i) = order[i];
       }
     }